LoadPal:
	movea.l	(A0)+, A1
	lea	Palettes+$180*ColourEntry, A2
	move.w	#$3f, D0
LoadColour:
	move.l	(A1)+, (A2)+
	dbra	D0, LoadColour
	rts

BG_ColourFilter:
	move.w	#GreyBrown, D2
	movea.l	(A0)+, A1
	lea	Palettes+$100*ColourEntry, A2
	move.w	#$7f, D1
	clr.w	D0
	move.b	(1,A1), D0
	asl.w	#8, D0
	move.b	(A1), D0
	addq	#2, A1
	move.w	D2, -(A7)
	move.w	D0, -(A7)
	andi.w	#$7c00, D0
	rol.w	#6, D0
	andi.w	#$7c00, D2
	rol.w	#6, D2
	add.b	D2, D0
	asr.b	#1, D0
	move.b	D0, D2
	andi.b	#1, D0
	asl.b	#1, D0
	andi.b	#$1e, D2
	asl.b	#3, D2
	or.b	D2, D0 ; get B component
	move.w	(2,A7), D2
	move.w	(A7), D3
	andi.w	#$3e0, D3
	asr.w	#5, D3
	andi.w	#$3e0, D2
	asr.w	#5, D2
	add.b	D2, D3
	asr.b	#1, D3
	move.b	D3, D2
	andi.b	#1, D3
	asl.b	#2, D3
	andi.b	#$1e, D2
	asl.w	#7, D2
	or.w	D3, D2
	or.w	D2, D0 ; then G
	move.w	(2,A7), D2
	move.w	(A7)+, D3
	andi.w	#$1f, D3
	andi.w	#$1f, D2
	add.b	D2, D3
	asr.b	#1, D3
	move.b	D3, D2
	andi.b	#1, D3
	asl.b	#3, D3
	andi.b	#$1e, D2
	ror.w	#5, D2
	or.w	D3, D2
	or.w	D2, D0 ; and finally R
	move.w	D0, (A2)+
	move.w	(A7)+, D2
	dbra	D1, $-$80
	rts

LoadPicture:
	clr.w	D0
	lea	Bitmap_RAM, A1
	move.w	(A0)+, D1
	move.w	(A0)+, D2
	subq	#1, D1
	subq	#1, D2
	move.l	A1, A2
	move.w	D1, D3
	move.b	(A0)+, D0
	move.w	D0, (A1)+
	dbra	D3, $-4
	adda.w	#$400, A2
	move.l	A2, A1
	dbra	D2, $-$10
	rts

DrawBorder:
	clr.w	D0
	lea	Bitmap_RAM, A1
	move.w	(A0)+, D1
	move.w	(A0)+, D2
	subq	#1, D1
	subq	#1, D2
	move.l	A1, A2
NewLine:
	move.w	D1, D3
LoadPixel:
	move.b	(A0)+, D0
	tst.b	D0
	beq.s	NextPixel
	addi.w	#$80, D0
	move.w	D0, (A1)
NextPixel:
	addq	#2, A1
	dbra	D3, LoadPixel
	adda.w	#$200*BitmapPixel, A2
	move.l	A2, A1
	dbra	D2, NewLine
	rts

scrollBG:
	move.w	D4, D0
	move.w	D5, D1
	subi.w	#$e, D1
	ori.w	#((1<<VisibilitySwitch)|(1<<BitmapSize)), D1
	move.w	D0, BG_ScrollX
	move.w	D1, BG_MultiReg
	rts